/*
 * Copyright ©2006 pinc Software. All Rights Reserved.
 * Distributed under the terms of the MIT License.
 */


#include "OptionKey.h"

#include <InterfaceDefs.h>
#include <Message.h>


OptionKey::OptionKey()
{
}


OptionKey::~OptionKey()
{
}


void
OptionKey::_FilterModifiers(BMessage* message, const char* name)
{
	int32 modifiers;
	if (message->FindInt32(name, &modifiers) != B_OK)
		return;

	if (modifiers & B_RIGHT_CONTROL_KEY) {
		// Replace right control key with option key
		modifiers &= ~(B_RIGHT_CONTROL_KEY | B_CONTROL_KEY);
		modifiers |= B_OPTION_KEY;

		message->ReplaceInt32(name, modifiers);
	}
}


filter_result
OptionKey::Filter(BMessage* message, BList* /*outList*/)
{
	if (message->what == B_MODIFIERS_CHANGED)
		_FilterModifiers(message, "be:old_modifiers");

	_FilterModifiers(message, "modifiers");

	return B_DISPATCH_MESSAGE;
}


//	#pragma mark -


BInputServerFilter*
instantiate_input_filter()
{
	return new OptionKey();
}
